module Camera (Camera (..), makeCamera) where

import Linear.V3
import Linear.Vector
import Maths

data Camera = Camera {origin :: V3 Double, lowerLeft :: V3 Double, horizontal :: V3 Double, vertical :: V3 Double}

--lookat :: V3 Double, vup :: V3 Double}

makeCamera :: V3 Double -> V3 Double -> V3 Double -> Double -> Double -> Camera
makeCamera o lookat vup vfov aspect = do
  let t = degToRadians vfov
  let h = tan (t / 2)
  let vh = 2.0 * h
  let vw = aspect * vh

  let w = unitVector (o ^-^ lookat)
  let u = unitVector (cross vup w)
  let v = cross w u

  let horizontal = vw *^ u
  let vertical = vh *^ v
  let lowerLeft = o ^-^ (horizontal ^/ 2) ^-^ (vertical ^/ 2) ^-^ w
  Camera o lowerLeft horizontal vertical
